Public Member Functions | Private Types | Private Attributes

# IndustryViewWindow Class Reference

Inheritance diagram for IndustryViewWindow:

## Public Member Functions
| IndustryViewWindow (WindowDesc *desc, WindowNumber window_number)
virtual void | OnPaint ()
| The window must be repainted.
int | DrawInfo (uint left, uint right, uint top)
| Draw the text in the WID_IV_INFO panel.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
## Private Types
enum | Editability { EA_NONE, EA_MULTIPLIER, EA_RATE }
| Modes for changing production. More...
enum | InfoLine { IL_NONE, IL_MULTIPLIER, IL_RATE1, IL_RATE2 }
| Specific lines in the info panel. More...
## Private Attributes
Editability | editable
| Mode for changing production.
InfoLine | editbox_line
| The line clicked to open the edit box.
InfoLine | clicked_line
| The line of the button that has been clicked.
byte | clicked_button
| The button that has been clicked (to raise).
int | production_offset_y
| The offset of the production texts/buttons.
int | info_height
| Height needed for the WID_IV_INFO panel.

## Detailed Description

Definition at line 645 of file industry_gui.cpp.

## Member Enumeration Documentation

enum IndustryViewWindow::Editability`[private]`

Modes for changing production.

Enumerator:

  EA_NONE | Not alterable.
  EA_MULTIPLIER | Allow changing the production multiplier.
  EA_RATE | Allow changing the production rates.

Definition at line 648 of file industry_gui.cpp.

enum IndustryViewWindow::InfoLine`[private]`

Specific lines in the info panel.

Enumerator:

  IL_NONE | No line.
  IL_MULTIPLIER | Production multiplier.
  IL_RATE1 | Production rate of cargo 1.
  IL_RATE2 | Production rate of cargo 2.

Definition at line 655 of file industry_gui.cpp.

## Member Function Documentation

int IndustryViewWindow::DrawInfo | ( | uint | left,
|  | uint | right,
|  | uint | top |
| ) |  |  | `[inline]`

Draw the text in the WID_IV_INFO panel.

Parameters:

  | left | Left edge of the panel.
  | right | Right edge of the panel.
  | top | Top edge of the panel.

Returns:
  Expected position of the bottom edge of the panel.

Definition at line 707 of file industry_gui.cpp.

References Industry::accepts_cargo, CALLBACK_FAILED, IndustrySpec::callback_mask, CBID_INDUSTRY_WINDOW_MORE_TEXT, CBM_IND_PRODUCTION_256_TICKS, CBM_IND_PRODUCTION_CARGO_ARRIVAL, CBM_IND_WINDOW_MORE_TEXT, clicked_button, clicked_line, CST_VIEW, CT_INVALID, DrawArrowButtons(), DrawString(), DrawStringMultiLine(), EA_MULTIPLIER, EA_RATE, editable, ErrorUnknownCallbackResult(), CargoSpec::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), GetAllCargoSuffixes(), GetGRFStringID(), GetIndustryCallback(), GetIndustrySpec(), IndustrySpec::grf_prop, GRFFilePropsBase< Tcnt >::grffile, HasBit(), IL_MULTIPLIER, IL_RATE1, Industry::incoming_cargo_waiting, Industry::last_month_pct_transported, Industry::last_month_production, lengthof, Industry::location, CargoSpec::name, Industry::prod_level, PRODLEVEL_CLOSURE, PRODLEVEL_DEFAULT, PRODLEVEL_MAXIMUM, PRODLEVEL_MINIMUM, Industry::produced_cargo, production_offset_y, Industry::production_rate, RoundDivSU(), SetDParam(), SetDParamStr(), SETTING_BUTTON_WIDTH, StartTextRefStackUsage(), StopTextRefStackUsage(), OrthogonalTileArea::tile, ToPercent8(), Industry::type, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_FRAMETEXT_LEFT, and Window::window_number.

Referenced by OnPaint().

virtual bool IndustryViewWindow::IsNewGRFInspectable | ( |  | ) | const`[inline, virtual]`

Is the data related to this window NewGRF inspectable?

Returns:
  true iff it is inspectable.

Reimplemented from Window.

Definition at line 986 of file industry_gui.cpp.

References Window::window_number.

virtual void IndustryViewWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 826 of file industry_gui.cpp.

References _ctrl_pressed, clicked_button, clicked_line, CS_ALPHANUMERAL, CT_INVALID, NWidgetBase::current_x, EA_MULTIPLIER, EA_NONE, EA_RATE, editable, editbox_line, FONT_HEIGHT_NORMAL, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), OrthogonalTileArea::GetCenterTile(), IL_NONE, IL_RATE1, IsInsideBS(), IsInsideMM(), Window::left, lengthof, Industry::location, max(), minu(), NWidgetBase::pos_x, Industry::prod_level, PRODLEVEL_DEFAULT, PRODLEVEL_MAXIMUM, PRODLEVEL_MINIMUM, Industry::produced_cargo, production_offset_y, Industry::production_rate, RoundDivSU(), ScrollMainWindowToTile(), Window::SetDirty(), SetDParam(), Window::SetTimeout(), SETTING_BUTTON_WIDTH, ShowExtraViewPortWindow(), ShowIndustryCargoesWindow(), ShowQueryString(), Industry::type, WID_IV_DISPLAY, WID_IV_GOTO, WID_IV_INFO, and Window::window_number.

virtual void IndustryViewWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 974 of file industry_gui.cpp.

References EA_RATE, editable, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), GetIndustrySpec(), Industry::type, IndustrySpec::UsesSmoothEconomy(), and Window::window_number.

virtual void IndustryViewWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 685 of file industry_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, DrawInfo(), Window::DrawWidgets(), info_height, Window::IsShaded(), NWidgetBase::pos_x, NWidgetBase::pos_y, and Window::ReInit().

virtual void IndustryViewWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 948 of file industry_gui.cpp.

References ClampU(), editbox_line, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), IL_MULTIPLIER, IL_NONE, Industry::prod_level, PRODLEVEL_DEFAULT, PRODLEVEL_MAXIMUM, PRODLEVEL_MINIMUM, Industry::production_rate, RoundDivSU(), Window::SetDirty(), StrEmpty(), and Window::window_number.

virtual void IndustryViewWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 938 of file industry_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), ScrollWindowToTile(), NWidgetViewport::UpdateViewportCoordinates(), Window::viewport, and Window::window_number.

virtual void IndustryViewWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 816 of file industry_gui.cpp.

References SetDParam(), WID_IV_CAPTION, and Window::window_number.

virtual void IndustryViewWindow::ShowNewGRFInspectWindow | ( |  | ) | const`[inline, virtual]`

Show the NewGRF inspection window.

When this function is called it is up to the window to call and pass the right parameters to the ShowInspectWindow function.

Precondition:
  this->IsNewGRFInspectable()

Reimplemented from Window.

Definition at line 991 of file industry_gui.cpp.

References Window::window_number.

virtual void IndustryViewWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 821 of file industry_gui.cpp.

References info_height, and WID_IV_INFO.

The documentation for this class was generated from the following file:

- src/industry_gui.cpp